/* Sistemas Integrados TEKNISA

   Nome: 0000_FASSTPO_FATURA_LICENCA_USO.SQL

   Descrio:
   Procedimento para Faturamento de Vendas de Licena de Uso.

   Criao:
   05/05/2006 Gustavo de Castro Camillo Lima Trad

*/
CREATE OR REPLACE PROCEDURE FATURA_LICENCA_USO(
  P_CDEMPRESA     IN APURFATUFAS.CDEMPRESA%TYPE,
  P_CLIENTE       IN CLIENTE.CDCLIENTE%TYPE,
  P_DTVELUSOPEDC  IN VENCLUSOCLIE.DTVELUSOPEDC%TYPE,
  P_CDOPERAPUR    IN APURFATUFAS.CDOPERAPUR%TYPE)
AS
  V_INVOICE     NUMBER;
  V_NRINVOICE   VARCHAR2(10);
  V_CDPAIS      VARCHAR2(4);
  V_CODPRODUTO  VARCHAR2(10);
  V_PRXAPURACAO VARCHAR2(20);
  V_GRAVA_EMP   VARCHAR2(3);
BEGIN
  SELECT MAX(CDPROFATLUSO)
  INTO V_CODPRODUTO
  FROM PAR_GERAL_FAS;
  --
  FOR CUR_TOTAL IN (SELECT  V.VRVELUSOPEDC, V.NRPROPOSFAS, V.NRVERPROPFAS, R.CDFILIAL, C.NRLINPPEDP, V.CDCLIENTE, F.CDEMPRESA, S.NMLINPPROP
                    FROM    VENCLUSOCLIE V, PEDILINPCLIE C, PEDILINPPROP P, PROPOSTAFAS R, EMPRESA E, FILIAL F, CLIENTE L, PROPOSTALINP S
                    WHERE   V.DTVELUSOPEDC  <= TO_DATE(P_DTVELUSOPEDC,'DD/MM/YYYY')                     	AND
                            V.NRAPURFATFAS IS NULL                                                      	AND
                            V.CDCLIENTE    = C.CDCLIENTE    (+) AND P.CDCLIENTE    (+) = C.CDCLIENTE 	 	AND
                            V.NRPROPOSFAS  = C.NRPROPOSFAS  (+) AND P.NRPROPOSFAS  (+) = C.NRPROPOSFAS   	AND 
			    S.NRPROPOSFAS    = C.NRPROPOSFAS							AND
                            V.NRVERPROPFAS = C.NRVERPROPFAS (+) AND P.NRVERPROPFAS (+) = C.NRVERPROPFAS  	AND
			    S.NRVERPROPFAS   = C.NRVERPROPFAS 							AND
			    V.NRLINPPEDP   = C.NRLINPPEDP   (+) AND P.NRLINPPEDP   (+) = C.NRLINPPEDP   	AND
			    S.CDLINPPROP   = P.CDLINPPROP     							AND
                            R.NRPROPOSFAS  = V.NRPROPOSFAS      AND R.NRVERPROPFAS     = V.NRVERPROPFAS 	AND
                            F.CDFILIAL     = R.CDFILIAL                                                 	AND
                            R.CDCLIENTE    = L.CDCLIENTE                                                	AND
                            F.CDEMPRESA    = E.CDEMPRESA                                                	AND
                            ((INSTR(P_CLIENTE,  C.CDCLIENTE)>0) OR (P_CLIENTE   = 'C'))                 	AND
                            ((INSTR(P_CDEMPRESA,E.CDEMPRESA)>0) OR (P_CDEMPRESA = 'E'))
                    ORDER BY
                            V.VRVELUSOPEDC)LOOP
      --
      SELECT MAX(F.CDEMPRESA)
      INTO   V_GRAVA_EMP
      FROM   FILIAL F
      WHERE  F.CDEMPRESA = CUR_TOTAL.CDEMPRESA;
      --
      SELECT MAX(E.CDPAIS)
      INTO   V_CDPAIS
      FROM   CLIENTE C, ENDECLIE E
      WHERE  (C.CDCLIENTE = E.CDCLIENTE) AND (E.IDTPENDECLIE = 'P') AND (C.CDCLIENTE = CUR_TOTAL.CDCLIENTE);
      --
      IF (V_CDPAIS <> '0055') AND (NOT(V_CDPAIS IS NULL)) THEN
          --
          SELECT MAX(TO_NUMBER(NRINVOICE))
          INTO   V_INVOICE
          FROM   INVOICE I, CLIENTE C
          WHERE  (I.CDCLIENTE = C.CDCLIENTE) AND (I.CDCLIENTE = CUR_TOTAL.CDCLIENTE);
          --
          IF V_INVOICE IS NULL THEN
              V_INVOICE := 1;
          ELSE
              V_INVOICE := V_INVOICE + 1;
          END IF;
          --
          V_NRINVOICE := TO_CHAR(V_INVOICE);
          V_NRINVOICE := LPAD(V_NRINVOICE,10,'0');
          --
          INSERT INTO INVOICE (
              CDFILIAL,
              NRINVOICE,
              CDEMPRESA,
              CDCLIENTE,
              CDTPBAIXAREC,
              CDTPINDICE,
              IDPERVALOR,
              CDINDICE,
              CDFILIALNF,
              NRLANCTONF,
              DTINVOICE,
              DTVENINVOICE,
              DSLOCAEMBARQ,
              IDGERNFINVOI,
              DTRECINVOICE,
              VRPEACRINVOI
          ) VALUES (
              CUR_TOTAL.CDFILIAL,
              V_NRINVOICE,
              V_GRAVA_EMP,
              CUR_TOTAL.CDCLIENTE,
              (SELECT CDTPBAIXAREC FROM TIPOBAIXAREC WHERE ROWNUM = 1),
              (SELECT CDTPINDICE   FROM CLIENTE C    WHERE (C.CDCLIENTE = CUR_TOTAL.CDCLIENTE) AND (ROWNUM = 1)),
              (SELECT IDPERVALOR   FROM CLIENTE C    WHERE (C.CDCLIENTE = CUR_TOTAL.CDCLIENTE) AND (ROWNUM = 1)),
              (SELECT CDINDICE     FROM CLIENTE C    WHERE (C.CDCLIENTE = CUR_TOTAL.CDCLIENTE) AND (ROWNUM = 1)),
              NULL,
              NULL,
              (SELECT TO_DATE(SYSDATE) FROM DUAL),
              P_DTVELUSOPEDC,
              NULL,
              'N',
              NULL,
              NULL
          );
          --
          INSERT INTO ITEMINVOICE (
              CDFILIAL,
              NRINVOICE,
              NRSEQITINVOI,
              CDPRODUTO,
              VRUNITEINVOI,
              DSEMISSINVOI,
              CDTIPOSERV
          ) VALUES (
              CUR_TOTAL.CDFILIAL,
              V_NRINVOICE,
              1,
              V_CODPRODUTO,
              CUR_TOTAL.VRVELUSOPEDC,
              NULL,
              NULL
          );
      ELSE
          V_NRINVOICE := NULL;
      END IF;
      --
      IF NOT(CUR_TOTAL.VRVELUSOPEDC IS NULL) AND (CUR_TOTAL.VRVELUSOPEDC>0) THEN
          --
          NOVO_CODIGO('APURFATUFAS',V_PRXAPURACAO);
          --
          INSERT INTO APURFATUFAS (
              CDFILIAL,
              CDCLIENTE,
              NRAPURFATFAS,
              DTAPURFATFAS,
              VRTOTAFATFAS,
              DSEMISSPRONF,
              CDOPERAPUR,
              CDEMPRESA,
              CDTIPOSERV,
              CDPRODUTO,
              NRLANCTONF,
              NRINVOICE,
              IDAPURFATFAS,
 	      IDSTAPFATFAS,
	      IDCOMIFATFAS,
              DSBOLEFATFAS
          ) VALUES (
              CUR_TOTAL.CDFILIAL,
              CUR_TOTAL.CDCLIENTE,
              SUBSTR(V_PRXAPURACAO,11,10),
              (SELECT TO_DATE(SYSDATE) FROM DUAL),
              CUR_TOTAL.VRVELUSOPEDC,
              ('Licena de Uso - '||CUR_TOTAL.NMLINPPROP),
              P_CDOPERAPUR,
              V_GRAVA_EMP,
              NULL,
              V_CODPRODUTO,
              NULL,
              V_NRINVOICE,
              '5',
	      'P',
              'N',
              (SELECT DSBOLETCLIE FROM PARCLIEFAS WHERE CDCLIENTE = CUR_TOTAL.CDCLIENTE AND IDTPFATUCLIE = '2')
          );
          --
          UPDATE  VENCLUSOCLIE
          SET     NRAPURFATFAS  = SUBSTR(V_PRXAPURACAO,11,10)
          WHERE   (DTVELUSOPEDC <= P_DTVELUSOPEDC)        AND
                  (NRAPURFATFAS IS NULL)                  AND
                  (CDCLIENTE    = CUR_TOTAL.CDCLIENTE)    AND
                  (NRPROPOSFAS  = CUR_TOTAL.NRPROPOSFAS)  AND
                  (NRVERPROPFAS = CUR_TOTAL.NRVERPROPFAS) AND
                  (NRLINPPEDP   = CUR_TOTAL.NRLINPPEDP);
      END IF;
  END LOOP;
  -- TRANSAO EXPLCITA
  COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('FATURA_LICENCA_USO','4.11.026'); END;
/

