var Dfe60001_Relatorio_Manifestacao_Destinatario_Controller = function(General, templateManager, ScreenService, ZhReports) {
    var self = this;
    
    var messages = {
        confirmaDesconhecimento: 'Atenção! Após confirmar a operação não será mais possível importar o XML da mesma. Deseja confirmar a operação?',
        nenhumaNota: 'Não é possivel realizar a operação para a(s) nota(s) selecionadas.',
        confirmarOperacao: 'Atenção! Deseja confirmar a operação para todas as notas marcadas?'
        
    };
    
    this.filterBefore = [];
    
    var requestError = function(error){
        var errorMessage = "Ocorreu um erro ao tentar realizar a operação.";
        if (error && error.data) {
            errorMessage = error.data.error;
        }
        ScreenService.showMessage(errorMessage, "ERROR");
    };

    var validaCampoCnpj = function(manifestacaoArgs) {
        var cnpj = manifestacaoArgs.owner.field.widget.getField("NRINSJURIEST");
        cnpj.readOnly = !manifestacaoArgs.row.CDEMPRESA;
        cnpj.setValue('');
        validaCampoInscricaoEstadual(manifestacaoArgs);
    };

    var validaCampoInscricaoEstadual = function(manifestacaoArgs) {
        var inscricaoEstadual = manifestacaoArgs.owner.field.widget.getField("CDINSCESTA");
        inscricaoEstadual.readOnly = !manifestacaoArgs.row.NRINSJURIEST;
        inscricaoEstadual.setValue('');
    };

    this.empresaOnChange = function(manifestacaoArgs) {
        validaCampoCnpj(manifestacaoArgs);
    };

    this.cnpjOnChange = function(manifestacaoArgs) {
        validaCampoInscricaoEstadual(manifestacaoArgs);
    };

    var getManifestacaoWidget = function(){
        if(templateManager.container)
            return templateManager.container.getWidget("manifestacao");
    };

    this.getCurrentField = function(field) {
        var manifestacaoWidget = getManifestacaoWidget();
        if (manifestacaoWidget)
            return !manifestacaoWidget.currentRow[field] ? null : manifestacaoWidget.currentRow[field];
    };

    var getFilterPopupCurrentRow = function(args){
        return args.owner.appliedFilter.FILTER_ROW;
    };

    this.getEmpresaFiltrada = function(){
        var manifestacaoWidget = getManifestacaoWidget();
        if(manifestacaoWidget){
            return manifestacaoWidget.appliedFilter.FILTER_ROW.CDEMPRESA;
        }
    };
    
    this.coloreLegenda = function(widgetGrid){
        var widget = widgetGrid.container.getWidget('legendaStripe');
        setTimeout(()=>{
            widget.getField('LEGENDAGRAY').element[0].style.color = 'gray';
            widget.getField('LEGENDARED').element[0].style.color = 'red';
            widget.getField('LEGENDAGREEN').element[0].style.color = 'green';
            widget.getField('LEGENDABLUE').element[0].style.color = 'blue';
        },500);
    };

    this.getFieldFromFilterPopup = function(field, concat = true){
        var manifestacaoWidget = getManifestacaoWidget();
        if(manifestacaoWidget){
            var widgetAtiva = manifestacaoWidget.getParent().getActiveWidget();
            if(widgetAtiva.name == 'zhFilterPreferencesSelectConditions')
                if(widgetAtiva.currentRow[field]){
                    if(widgetAtiva.currentRow[field].length > 0 && concat)
                        return widgetAtiva.currentRow[field] || 'TD';//return widgetAtiva.currentRow[field].toString().replace(/,/g, '_');
                    else
                        return widgetAtiva.currentRow[field] || 'TD';
                }
                else    
                    return widgetAtiva.currentRow[field] || 'TD';
            else
                return manifestacaoWidget.appliedFilter.FILTER_ROW[field] || 'TD';
        }
    };

    this.idorigdestOnChange = function(filterArgs) {
        alteraVisibilidadeCampoInscricaoFiltro(filterArgs);
        limpaCamposOutDataSelectsTpOperacFiltro(filterArgs);
    };
    

    var alteraVisibilidadeCampoInscricaoFiltro = function(filterArgs) {
        var filtroWidget = filterArgs.owner.field.widget;
        var cliente = filtroWidget.getField("NMRAZSOCCLIE");
        var fornecedor = filtroWidget.getField("NMRAZSOCFORN");
        var filial = filtroWidget.getField("DSFILIEMIT");
        var tipoDestino = filterArgs.row.IDORIGDESTNF;

        switch (tipoDestino) {
            case "C":
                validacaoCamposOutTpOperacFilter(cliente, fornecedor, filial);
                break;
            case "F":
                validacaoCamposOutTpOperacFilter(fornecedor, cliente, filial);
                break;
            case "L":
                validacaoCamposOutTpOperacFilter(filial, fornecedor, cliente);
                break;
            default:
                filial.readOnly = true;
                cliente.readOnly = true;
                fornecedor.readOnly = true;
        }
    };

    var limpaCamposOutDataSelectsTpOperacFiltro = function(filterArgs)
    {
        var filtroWidget = filterArgs.owner.field.widget;
        var cabecalhoRow = filtroWidget.currentRow;
        var cliente = filtroWidget.getField("NMRAZSOCCLIE");
        var fornecedor = filtroWidget.getField("NMRAZSOCFORN");
        var filial = filtroWidget.getField("DSFILIEMIT");

        filial.value(null);

        cliente.value(null);
        cabecalhoRow.CDCLIENTE = null;

        fornecedor.value(null);
        cabecalhoRow.CDFORNECED = null;
        cabecalhoRow.IDSITUCADA = null;
        cabecalhoRow.IDBLQNFRELAFOAF = null;

        cabecalhoRow.NRINSJURNF = null;
        cabecalhoRow.NMINSJURNF = null;
        cabecalhoRow.IDTPINSJURNF = null;
    };

    var validacaoCamposOutTpOperacFilter = function(princialField) {
        princialField.showOnView = true;
        princialField.showOnForm = true;
        princialField.isVisible = true;
        princialField.readOnly = false;

        for (var i = 1; i < arguments.length; i++) {
            arguments[i].showOnView = false;
            arguments[i].showOnForm = false;
            arguments[i].isVisible = false;
            arguments[i].readOnly = true;
        }
    };
    
     this.ajustaFilterBeforeApply = function(args){
        var preference = args.e.preference;
        var manifestacaoWidget = args.owner;
        preference.CUSTOM_FILTER_ROW = Util.clone(preference.FILTER_ROW);
        manifestacaoWidget.dataSourceFilter.forEach(element =>{
            var eName = element.name;
            preference.CUSTOM_FILTER_ROW[eName] = element.value;
        });
    };

    this.criaDataSourceGridFilterAfterApply = function(args) {
        var manifestacaoWidget = args.owner;
        var dataSourceFilter = manifestacaoWidget.dataSourceFilter;
        /*dataSourceFilter = dataSourceFilter.filter(function(value) {
            return value.name !== 'P_DTEMISSAOINI' && value.name !== 'P_DTEMISSAOFIN' && (value.isCustomFilter !== true || value.name === 'DTEMISSAO'); 
        });
        var datasFiltro = dataSourceFilter.filter(function(value) {
            return value.name === "DTEMISSAO";
        });
        var filterDefault = {
            'operator': '='
        };
        datasFiltro.forEach(function(data) {
            filterDefault.name = 'P_' + data.name + 'INI';
            filterDefault.value = data.value[0];
            dataSourceFilter.push(Util.clone(filterDefault));
            filterDefault.name = 'P_' + data.name + 'FIN';
            filterDefault.value = data.value[1];
            dataSourceFilter.push(Util.clone(filterDefault));

            if(dataSourceFilter.indexOf(data) > 0)
                dataSourceFilter.splice(dataSourceFilter.indexOf(data), 1);
        });*/
        
        
        
        //manifestacaoWidget.dataSourceFilter = dataSourceFilter;
        
        /*setTimeout(()=>{
            manifestacaoWidget.reload();
        },600);*/
    };

    this.abrirPopupJustificativa = function(args){
        var notas = args.owner.widget.getCheckedRows().filter(function(notafiscal){
                    return !notafiscal.NRLANCTONF && notafiscal.IDSTATUSMANIF !== "3";
                });

        if(notas.length > 0){
            var popupJustificativa = args.owner.widget.container.getWidget('popupJustificativa');
            ScreenService.openPopup(popupJustificativa);
        }
        else{
            ScreenService.showMessage(messages.nenhumaNota);
        }
    };

    this.openPopupErros = function(erros) {
        var widgetErros = templateManager.container.getWidget('WidgetErros');
        widgetErros.dataSource.data = erros;
        widgetErros.isVisible = true;
        ScreenService.openPopup(widgetErros);
        widgetErros.activate();
    };
    
    this.closeErros = function(widget) {
        widget.isVisible = false;
        widget.dataSource.data = [];
        ScreenService.closePopup(widget);
        widget.parent.activate();
        widget.parent.unSelectAll();
        widget.parent.reload();
        ScreenService.closePopup();
    };

    
    this.openPopupResumo = function(sincronizacao) {
        var wdgResumo = templateManager.container.getWidget('RESUMOSINC');
        wdgResumo.isVisible = true;
        wdgResumo.currentRow = sincronizacao[0].DADOS;
        wdgResumo.widgets[0].dataSourceFilter[0].value = sincronizacao[0].CHAVES; 
        wdgResumo.widgets[0].dataSourceFilter[0].operator = "IN";
        wdgResumo.widgets[0].reload();
        ScreenService.openPopup(wdgResumo);
    };
    
    this.closePopupResumo = function() {
        var wdgSinc = templateManager.container.getWidget('RESUMOSINC');
        ScreenService.closePopup();
        wdgSinc.isVisible = false;
    };
    
    this.openPopupSincronizacao = function() {
        var wdgSinc = templateManager.container.getWidget('WidgetSincronizacao');
        wdgSinc.currentRow.FORMAPESQUISA    = "0";
        wdgSinc.isVisible = true;
        ScreenService.openPopup(wdgSinc);
    };
    
    this.closePopupSincronizacao = function() {
        var wdgSinc = templateManager.container.getWidget('WidgetSincronizacao');
        ScreenService.closePopup();
        wdgSinc.isVisible = false;
    };
    
    this.closePopup = function(widget) {
        widget.isVisible = false;
        widget.dataSource.data = [];
        ScreenService.closePopup(widget);
        widget.parent.activate();
        widget.parent.unSelectAll();
        widget.parent.reload();
        ScreenService.closePopup();
    };
    
    this.generateReport = function(args, format) {
        let customData = {}, sourceWidget = templateManager.container.getWidget('manifestacao'), 
            action = (format == 'PDF') ? 'pdfAction' : 'xlsAction', IDORIGDESTNF = sourceWidget.appliedFilter.FILTER_ROW.IDORIGDESTNF;
       /* if(IDORIGDESTNF) {

            if(IDORIGDESTNF == 'F') {
                sourceWidget.floatingControl[action].dataSourceName = 'manifestacao_destinatario_relatorio_fornecedor';
            }
            else if(IDORIGDESTNF == 'C')  {
                sourceWidget.floatingControl[action].dataSourceName = 'manifestacao_destinatario_relatorio_cliente';
            }
            else {
                sourceWidget.floatingControl[action].dataSourceName = 'manifestacao_destinatario_relatorio_filial';
            }
        }
        else {
            sourceWidget.floatingControl[action].dataSourceName = 'manifestacao_destinatario_relatorio';
        }
        var filtroData = [
            {
                "name": "P_DTEMISSAOINI",
                "operator": "=",
                "value": ""
            },
            {
                "name": "P_DTEMISSAOFIN",
                "operator": "=",
                "value": ""
            }
        ];
        this.filterBefore = Util.clone(sourceWidget.dataSourceFilter);
        sourceWidget.dataSourceFilter.forEach((filter, index) => {
            if(filter.name == 'IDORIGDESTNF') {
                sourceWidget.dataSourceFilter = [...sourceWidget.dataSourceFilter.slice(0, index), ...sourceWidget.dataSourceFilter.slice(index+1, sourceWidget.dataSourceFilter.length)];
            }
            else if(filter.name == 'DTEMISSAO') {
                filtroData[0].value = filter.value[0];
                
                filtroData[1].value = filter.value[1];
                //sourceWidget.dataSourceFilter = [...sourceWidget.dataSourceFilter.slice(0, index), ...sourceWidget.dataSourceFilter.slice(index+1, sourceWidget.dataSourceFilter.length)];
                sourceWidget.dataSourceFilter = [...sourceWidget.dataSourceFilter, ...filtroData];
                var filtro = sourceWidget.dataSourceFilter.filter(data => {
                   if(data.name != 'DTEMISSAO') {
                        if(data.value.indexOf('Dfe60001_Relatorio_Manifestacao_Destinatario_Controller') != -1) {
                            data.value = sourceWidget.appliedFilter.FILTER_ROW[data.name] || 'TD';
                        }
                        return data;
                   }
                });
                sourceWidget.dataSourceFilter = filtro;
            }
        });*/
        
        
        ZhReports.generateReport(customData, sourceWidget, this._previewCallback, function() {}, format);
        //templateManager.container.getWidget('manifestacao').dataSourceFilter = self.filterBefore;


    };
    
    this._previewCallback = function(data) {
        //templateManager.container.getWidget('manifestacao').dataSourceFilter = self.filterBefore;
        var popup_window = window.open(data.path, '_blank');
        if (!popup_window) {
            ScreenService.showMessage(ScreenService.i18n('Pop-up Blocker is enabled! Please add this site to your exception list.'));
        }
        if (callback) {
            callback(data);
        }
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfe60001_Relatorio_Manifestacao_Destinatario_Controller", Dfe60001_Relatorio_Manifestacao_Destinatario_Controller);
});